package org.one.stone.soup.browser;

import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.io.PrintWriter;
import java.net.URLConnection;
import java.net.URLEncoder;

public class BrowserFileOutputStream extends OutputStream
{
	private URLConnection connection;
	private OutputStream delegate;
	private InputStream iStream;
	
	public BrowserFileOutputStream(URLConnection connection,String fileName) throws IOException
	{
		this.connection = connection;
		this.delegate = connection.getOutputStream();
		
		PrintWriter out = new PrintWriter( delegate );

		out.println("--"+BrowserURLFactory.FORM_BOUNDARY);
		out.println("Content-Disposition: form-data; name=\"filename\"; filename=\""+URLEncoder.encode(fileName,"UTF-8")+"\"");
		out.println("Content-Type: application/octet-stream");
		out.println();
		out.flush();
		delegate.flush();
		iStream = connection.getInputStream();
	}

	public void close() throws IOException {
		Browser.closeURLPostFileConnection( connection,delegate );
		delegate.close();
	}

	public boolean equals(Object obj) {
		return delegate.equals(obj);
	}

	public void flush() throws IOException {
		delegate.flush();
	}

	public int hashCode() {
		return delegate.hashCode();
	}

	public String toString() {
		return delegate.toString();
	}

	public void write(byte[] b, int off, int len) throws IOException {
		delegate.write(b, off, len);
	}

	public void write(byte[] b) throws IOException {
		delegate.write(b);
	}

	public void write(int b) throws IOException {
		delegate.write(b);
	}
	
}
