package org.one.stone.soup.mjdb.data.field;

/*
 * MJDB (Micro Java Database) Version 1.0
 *
 * Copyright 2000-2001 by Wet-Wired.com Ltd.,
 * Portsmouth England
 * This software is OSI Certified Open Source Software
 * This software is covered by an OSI approved open source licence
 * which can be found at http://www.wet-wired.com/licence/license-os.html
 */

/**
	* The DateTimeField class is a wrapper for a combined Date and Time value.
	* @author Nik Cross
*/

public class DateTimeField extends Field {
	public static String DEFAULT_ID = "_DateTime";

	private DateField date = new DateField();
	private TimeField time = new TimeField();
public DateField addDays(int days) {

	return date.addDays(days);
}
public boolean after(DateField dte) {
	return date.after(dte);
}
public boolean after(DateField dte,boolean inclusive) {
	return date.after(dte,inclusive);
}
long asLong() {
	return date.asLong();
}
public boolean before(DateField dte) {
	return date.before(dte);
}
public boolean before(DateField dte,boolean inclusive) {
	return date.before(dte,inclusive);
}
public int compare(Field target) throws CompareException {
	return date.compare(target);
}
public String getConsiseDate() {
	return date.getConsiseDate();
}
public String getDay() {
	return date.getDay();
}
public String getMonth() {
	return date.getMonth();
}
public String getShortDate() {
	return date.getShortDate();
}
public DateField getStartOfWeek() {
	return date.getStartOfWeek();
}
public String getValue(String name) {
	return date.getValue(name);
}
public String getYear() {
	return date.getYear();
}
public boolean isSame(DateField dte){
	return date.isSame(dte);
}
public void setValue(String name, String value, Object source) throws LockException,ConstructException {
	date.setValue(name,value,source);
}
public String toString() {
	return date.getConsiseDate()+" "+time.toString();
}

public String getHours() {
	return time.getHours();
}

public String getMinutes() {
	return time.getMinutes();
}

public String getSeconds() {
	return time.getSeconds();
}

public void setDate(DateField d) {
	date = d;
}

public void setTime(TimeField t) {
	time = t;
}
}
