package org.one.stone.soup.mjdb.data.field;

/*
 * MJDB (Micro Java Database) Version 1.0
 *
 * Copyright 2000-2001 by Wet-Wired.com Ltd.,
 * Portsmouth England
 * This software is OSI Certified Open Source Software
 * This software is covered by an OSI approved open source licence
 * which can be found at http://www.wet-wired.com/licence/license-os.html
 */

/**
	* Classes that wish to receive notification of changes to Field subclasses
	* must implement this interface. To start listening to a specific instance
	* they call the Field's <code>addListener</code> method. When the Field's
	* data is changed the FieldListener's <code>receiveChange</code> method is
	* called, passing the <code>Field</code> that has changed, and the Object
	* instance that caused the change.
	* @author Nik Cross
*/

public interface FieldListener {
/**
 * Called when a Field that the FieldListener is listening to has its value
 * changed.
 * @param source	The object that has caused the change
 * @param data		The object that has been changed
 */
void receiveChange(Object source,Object data);
}
