package org.one.stone.soup.mjdb.data.field;

/*
 * MJDB (Micro Java Database) Version 1.0
 *
 * Copyright 2000-2001 by Wet-Wired.com Ltd.,
 * Portsmouth England
 * This software is OSI Certified Open Source Software
 * This software is covered by an OSI approved open source licence
 * which can be found at http://www.wet-wired.com/licence/license-os.html
 */

/**
	* The Index class is a wrapper for an index value. It is used by
	* the mjdb Sort function.
	* @author Nik Cross
*/
public class Index extends IntField{
	public static String DEFAULT_ID = "_Index";

	public static final int NOT_SET=-1;
/**
 * This constructor creates a new Index with the value not set (-1).
 */

public Index() {
	super();

	try{
		setValue(NOT_SET,this);
	}
	catch(LockException le){}// dummy catch
}
/**
 * This constructor creates a new Index.
 * @param newValue		The index value
 */

public Index(int newValue) {
	super();

	try{
		setValue(newValue,this);
	}
	catch(LockException le){}// dummy catch

}
/**
 * Sets the index value as not set (-1).
 */
public void reset() throws LockException {

	setValue(NOT_SET,this);
}
}
