package org.one.stone.soup.mjdb.data.field;

/*
 * MJDB (Micro Java Database) Version 1.0
 *
 * Copyright 2000-2001 by Wet-Wired.com Ltd.,
 * Portsmouth England
 * This software is OSI Certified Open Source Software
 * This software is covered by an OSI approved open source licence
 * which can be found at http://www.wet-wired.com/licence/license-os.html
 */

/**
	* Classes that wish to lock <code>Lockable</code> objects.
	* @author Nik Cross
*/

public interface LockOwner {
/**
 * Called when a <code>Lockable</code> class has been requested to unlock
 * its data. Returns true if the data can be unlocked by the requester.
 * @param data			The object that has been requested to unlock
 * @param requester		The object that has requested to unlock the data
 */

boolean canForceUnlock( Lockable data,LockOwner requester );
}
