package org.one.stone.soup.mjdb.data.functions;

import org.one.stone.soup.mjdb.data.field.*;
import org.one.stone.soup.mjdb.data.group.*;

/*
 * MJDB (Micro Java Database) Version 1.0
 *
 * Copyright 2000-2001 by Wet-Wired.com Ltd.,
 * Portsmouth England
 * This software is OSI Certified Open Source Software
 * This software is covered by an OSI approved open source licence
 * which can be found at http://www.wet-wired.com/licence/license-os.html
 */

public final class Distinct {
public static final Table distinctCount(Table table,int column) throws JoinException{

	Table result = new Table(2);
 try{
	result.setColumnTitle(0,table.getColumnTitle(column),table);
	result.setColumnTitle(1,"count",table);

	Row row;
	Table find;

	for(int loop=0;loop<table.getNoOfRows();loop++)
	{
		Field field = (Field)(table.getField(column,loop));

		find = Search.search(result,0,field);
		if(find.getNoOfRows()>0)
		{
			IntField count = (IntField)(find.getRow(0).getField(1));
			count.inc(table);
		}
		else
		{
			row = new Row(2);
			row.setField(0,field,table);
			row.setField(1,new IntField(1),table);
			result.addRow(row,table);
		}
	}
 }catch(Exception e)
 {
	 e.printStackTrace();
 }

	return result;
}
}
