package org.one.stone.soup.mjdb.data.functions;

import org.one.stone.soup.mjdb.data.field.*;


/*
 * MJDB (Micro Java Database) Version 1.0
 *
 * Copyright 2000-2001 by Wet-Wired.com Ltd.,
 * Portsmouth England
 * This software is OSI Certified Open Source Software
 * This software is covered by an OSI approved open source licence
 * which can be found at http://www.wet-wired.com/licence/license-os.html
 */

/**
	* The Wrapper class is a helper class that attempts to wrap supplied values
	* in a Field wrapper.
	* @author Nik Cross
*/

public final class Wrapper {
public static final Object wrap(Object data) {

	if(data instanceof Field)
	{
		return data;
	}

	Object result=null;
	boolean set=false;

	if(data instanceof StringBuffer)
	{
		data = ((StringBuffer)data).toString();
	}

	if(data instanceof String)
	{
		String text = (String)data;

		if(set==false)
		{
		  try{
			Integer i = new Integer(text);
			result = new IntField(i.intValue());
			set=true;
		  }
		  catch(Exception e)
		  {
			set=false;
		  }
		}

		if(set==false)
		{
		  try{
			Float f = new Float(text);
			result = new FloatField(f.floatValue());
			set=true;
		  }
		  catch(Exception e)
		  {
			set=false;
		  }
		}

		if(set==false)
		{
			if(text instanceof String)
			{
			if(((String)text).equals("true") || ((String)text).equals("false"))
			{
			  try{
				Boolean b = new Boolean(text);
				result = new BoolField(b.booleanValue());
				set=true;
			  }
			  catch(Exception e)
			  {
				set=false;
			  }
			}
			}
		}

		if(set==false)
		{
		  try{
			DateField d = new DateField(text);
			result = d;
			set=true;
		  }
		  catch(Exception e)
		  {
			set=false;
		  }
		}

		if(set==false)
		{
			result = new StringField(text);
		}
	}

	if(result==null)
	{
		//System.out.println(data.getClass()+"="+data+" not wrapped");
		return data;
	}
	else
	{
		//System.out.println(data+" wrapped as "+result.getClass());
		return result;
	}
}
}
