package org.one.stone.soup.mjdb.data.persistence;

import java.io.*;

import org.one.stone.soup.mjdb.data.group.*;

/*
 * MJDB (Micro Java Database) Version 1.0
 *
 * Copyright 2000-2001 by Wet-Wired.com Ltd.,
 * Portsmouth England
 * This software is OSI Certified Open Source Software
 * This software is covered by an OSI approved open source licence
 * which can be found at http://www.wet-wired.com/licence/license-os.html
 */

public class TableToCsv {
	OutputStream oStream;
	char separator;
	Table table;


public TableToCsv(OutputStream newStream,char newSep,Table newTable) throws DatabaseException
{
	this(newStream,newSep,newTable,true);
}
public TableToCsv(OutputStream newStream,char newSep,Table newTable,boolean hasColumnTitles) throws DatabaseException{
	super();

	oStream = newStream;
	separator = newSep;
	table = newTable;

	int rows = table.getNoOfRows();
	int cols = table.getNoOfColumns();

	PrintWriter out=new PrintWriter(oStream);

	//System.out.println("Saving table");

	if(hasColumnTitles==true)
	{
		for(int cloop=0;cloop<cols;cloop++)
		{
			if(cloop>0)
			{
				out.print(separator);
			}
			out.print(table.getColumnTitle(cloop));
			//System.out.println("Col:"+cloop+" Title:"+table.getColumnTitle(cloop));
		}
		out.println();
	}

	for(int rloop=0;rloop<rows;rloop++)
	{
	for(int cloop=0;cloop<cols;cloop++)
	{
		if(cloop>0)
			out.print(separator);

		out.print(table.getField(cloop,rloop));

		//System.out.print(table.getField(cloop,rloop)+", ");
	}
	out.println();
	//System.out.println();
	}
	out.flush();

	try{
		oStream.close();
	}
	catch(Exception e)
	{
		System.out.println("Failed to close csv file: "+e);
	}
}
}
