package org.one.stone.soup.net;

import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.net.Socket;

import org.one.stone.soup.io.Connection;

public class SocketConnection implements Connection {

	private Socket socket;
	private String alias;
	
	public SocketConnection(Socket socket,String alias)
	{
		this.socket = socket;
		this.alias = alias;
	}
	
	public InputStream getInputStream() throws IOException {
		return socket.getInputStream();
	}

	public OutputStream getOutputStream() throws IOException {
		return socket.getOutputStream();
	}

	public String getAlias() {
		return alias;
	}

	public long getDataSentSize() {
		return -1;
	}

	public void close() throws IOException {
		socket.close();
	}

}
