package org.one.stone.soup.xapp.swing.components;

import java.awt.*;
import java.awt.event.ActionListener;

import javax.swing.*;
import javax.swing.border.BevelBorder;
import javax.swing.border.SoftBevelBorder;

import org.one.stone.soup.swing.SimpleDirFilter;
import org.one.stone.soup.xapp.XappReceiver;
import org.one.stone.soup.xapp.components.compound.XappFileEntryField;
import org.one.stone.soup.xapp.dnd.XappDropReceiver;
import org.one.stone.soup.xapp.swing.dnd.XappSwingDropReceiver;
import org.one.stone.soup.xml.XmlElement;

import java.io.*;
/**
 * Insert the type's description here.
 * Creation date: (12/08/03 16:38:13)
 * @author:
 */
public class XappSwingFileEntryField extends JComponent implements java.awt.event.ActionListener,XappReceiver, XappFileEntryField{
	private JTextField file;
	private JButton browse;
	private boolean selectDirectory=false;

	private XappDropReceiver dropReceiver;
	private static String lastOpenDir;
/**
 * FileBrowser constructor comment.
 */
public XappSwingFileEntryField(){
	super();

	setLayout( new BorderLayout() );

	file = new JTextField(25);
	add(file,BorderLayout.WEST);

	browse = new JButton("Browse");
	add(browse,BorderLayout.EAST);
	browse.addActionListener(this);
	browse.setBorder( new SoftBevelBorder(BevelBorder.RAISED) );

	dropReceiver = new XappSwingDropReceiver(file,this,"FileEntryField",null);

}
	/**
	 * Invoked when an action occurs.
	 */
public void actionPerformed(java.awt.event.ActionEvent e)
{
	String fileName = selectFileOpen("Browse","All Files","*");

	if(fileName!=null)
	{
		setText(fileName);
	}
}
/**
 * Insert the method's description here.
 * Creation date: (12/08/03 16:43:54)
 * @param text java.lang.String
 */
public String getText()
{
	return file.getText();
}
private String selectFileOpen(String title,String fileType,String mask)
{
	File lastDirFile = null;

	if(lastOpenDir!=null)
	{
		lastDirFile = new File(lastOpenDir);
	}
	else
	{
		lastDirFile = new File("");
	}


	JFileChooser fd = new JFileChooser( lastDirFile );
	fd.setDialogTitle(title);

	if(selectDirectory)
	{
		fd.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
		fd.setFileFilter(new SimpleDirFilter());
		fd.showDialog( this,"Select" );
	}
	else
	{
		fd.setFileFilter(new org.one.stone.soup.swing.SimpleFileFilter(mask,fileType));
		fd.showOpenDialog( this );
	}

	File result = fd.getSelectedFile();

	String fileName=null;
	if(result!=null)
	{
		fileName = org.one.stone.soup.file.FileHelper.getPath(result.getPath());
		fileName += result.getName();
		lastOpenDir = org.one.stone.soup.file.FileHelper.getPath(result.getPath());
	}
	if(selectDirectory)
	{
		fileName = fileName+"/";
	}

	return fileName;
}
/**
 * Insert the method's description here.
 * Creation date: (12/08/03 16:43:54)
 * @param text java.lang.String
 */
public void setText(String text)
{
	file.setText(text);
	file.setToolTipText(text);
}

/* (non-Javadoc)
 * @see org.one.stone.soup.xapp.components.compound.XappFileEntryField#setSelectDirectory(boolean)
 */
public void setSelectDirectory(boolean state)
{
	selectDirectory = state;
}

public void setEnabled(boolean state)
{
	browse.setEnabled(state);
	file.setEnabled(state);
}

public void receiveXappData(XmlElement data)
{
	file.setText( data.getElementByIndex(0).getValue() );
}


public void setTip(String text)
{
	setToolTipText(text);
}
public void addActionListener(ActionListener actionListener) {
	// TODO Auto-generated method stub
	
}
public String getData() {
	return file.getText();
}
public void setData(String value) {
	file.setText(value);
}
public void setEditable(boolean state) {
	file.setEditable(state);
	browse.setEnabled(state);
}

}
