package org.one.stone.soup.xapp.swing.components;

import java.awt.Color;
import java.awt.Component;
import java.awt.LayoutManager;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.lang.reflect.Method;

import javax.swing.AbstractButton;
import javax.swing.JScrollPane;
import javax.swing.JTabbedPane;
import javax.swing.event.ChangeEvent;

import org.one.stone.soup.xapp.XappPersister;
import org.one.stone.soup.xapp.XappRootApplication;
import org.one.stone.soup.xapp.components.XappComponent;
import org.one.stone.soup.xapp.containers.XappContainer;
import org.one.stone.soup.xapp.containers.tabs.XappTab;
import org.one.stone.soup.xapp.containers.tabs.XappTabs;
import org.one.stone.soup.xml.XmlElement;
import org.one.stone.soup.xml.stream.XmlLoader;

public class XappSwingTabs extends JTabbedPane implements XappTabs{

	public class XTab implements XappTab
	{
		
		private String name;
		private XappSwingTabs tabs;
		
		private XTab(XappSwingTabs tabs,String name)
		{
			this.tabs = tabs;
			this.name = name;
		}

		public Component getComponent()
		{
			int index = getIndex();
			Component component = tabs.getComponentAt(index);
			
			if(component instanceof JScrollPane)
			{
				component = ((JScrollPane)component).getViewport().getComponent(0); 
			}
			
			return component;
		}
		
		public void removeComponent()
		{
			int index = getIndex();
			Component component = tabs.getComponentAt(index);

			tabs.remove( component );
		}
		
		public int getIndex()
		{
			for(int loop=0;loop<tabs.getTabCount();loop++)
			{
				if(tabs.getTitleAt(loop).equals(name))
				{
					return loop;
				}
			}
			return -1;
		}

		public void addElement(Component element) {
			JScrollPane pane = new JScrollPane();
			pane.setViewportView(element);
			tabs.setTabComponent(name,pane);
		}

		public void addGroupMember(String key, AbstractButton member) {
			// TODO Auto-generated method stub
			
		}

		public Color getBackground() {
			return tabs.getBackground();
		}

		public Color getForeground() {
			return tabs.getForeground();
		}

		public String getName() {
			return name;
		}

		public void setLayout(LayoutManager layout) {			
		}

		public void setName(String name) {
			this.name = name;
		}

		public void stateChanged(ChangeEvent e) {
			// TODO Auto-generated method stub
			
		}

		public void actionPerformed(ActionEvent e) {
			// TODO Auto-generated method stub
			
		}
		
		public void refresh()
		{
			doLayout();
		}

		public void add(String name, XappComponent component) {
			JScrollPane pane = new JScrollPane();
			pane.setViewportView((Component)component);
			tabs.setTabComponent(name,pane);
		}
		
		public void add(XappComponent component) {
			JScrollPane pane = new JScrollPane();
			pane.setViewportView((Component)component);
			tabs.setTabComponent(component.getName(),pane);
		}

		public void addActionListener(ActionListener actionListener) {
			// TODO Auto-generated method stub
			
		}

		public void setTip(String text)
		{
			setToolTipText(text);
		}

		public void setBackground(Color color) {
			// TODO Auto-generated method stub
			
		}

		public void setForeground(Color color) {
			// TODO Auto-generated method stub
			
		}
	}
	
	/* (non-Javadoc)
	 * @see org.one.stone.soup.xapp.containers.tabs.XappTabs#getTab(java.lang.String)
	 */
	public XappTab getTab(String tabName)
	{
		for(int loop=0;loop<getTabCount();loop++)
		{
			if(getTitleAt(loop).equals(tabName))
			{
				return new XTab(this,tabName);
			}
		}
		
		addTab(tabName,null);
		return new XTab(this,tabName);
	}
	
	/* (non-Javadoc)
	 * @see org.one.stone.soup.xapp.containers.tabs.XappTabs#setTabComponent(java.lang.String, java.awt.Component)
	 */
	public void setTabComponent(String tabName,Component component)
	{
		for(int loop=0;loop<getTabCount();loop++)
		{
			if(getTitleAt(loop).equals(tabName))
			{
				setComponentAt(loop,component);
			}
		}
	}

	/* (non-Javadoc)
	 * @see org.one.stone.soup.xapp.containers.tabs.XappTabs#getData()
	 */
	public XmlElement getData() {
		int tabs = getTabCount();
		XmlElement xTabs = new XmlElement("tabs");
		
		for(int loop=0;loop<tabs;loop++)
		{
			XmlElement xTab = xTabs.addChild("tab");
			xTab.addAttribute("name",getTitleAt(loop));
			
			Component component = ((XTab)getTab(getTitleAt(loop))).getComponent();
			if(component instanceof XappPersister)
			{
				xTab.addChild( ((XappPersister)component).getData() );
			}
		}
		
		return xTabs;
	}

	/* (non-Javadoc)
	 * @see org.one.stone.soup.xapp.containers.tabs.XappTabs#setData(org.one.stone.soup.xml.XmlElement)
	 */
	public void setData(XmlElement data) {
			
		for(int loop=0;loop<data.getElementCount();loop++)
		{
			XmlElement tab = data.getElementByIndex(loop);
			XmlElement xComponent = tab.getElementByIndex(0);
			
			XTab xTab = (XTab)getTab( tab.getAttributeValueByName("name") );
			if(xComponent==null)
			{
				continue;
			}
			else if(xComponent.getName().equals("spreadsheet"))
			{
				XappRootApplication.getComponentFactory().buildXappComponent( xTab,xComponent,this.getName(),XappRootApplication.getComponentStore() );
			}
			else if(xComponent.getName().equals("data"))
			{
				String source = xComponent.getAttributeValueByName("source");
				
				if(source!=null && source.indexOf("file://")==0)
				{
					XmlElement xForm = XmlLoader.load( source.substring(7) );
					XSwingForm form = (XSwingForm)XappRootApplication.getComponentFactory().buildContainer(xForm,XappRootApplication.getComponentStore());
					xTab.addElement(form);
				}
				
				XSwingForm form = (XSwingForm)xTab.getComponent();
				if(form!=null)
				{
					form.setData(xComponent);
				}
			}
		}
	}
	
	public String getValue()
	{
		return null;
	}

	public void add(String name, XappComponent component) {
		addTab(name,(Component)component);
	}

	public void add(XappComponent component) {
		addTab(component.getName(),(Component)component);
	}

	public void refresh() {
		// TODO Auto-generated method stub
		
	}

	public void actionPerformed(ActionEvent e) {
		// TODO Auto-generated method stub
		
	}

	public void addActionListener(ActionListener actionListener) {
		// TODO Auto-generated method stub
		
	}

	public void setTip(String text)
	{
		setToolTipText(text);
	}

	public void setOrientation(String orientation) {
		if(orientation!=null && orientation.equals("left"))
		{
			setTabPlacement(JTabbedPane.LEFT);
		}
		else if(orientation!=null && orientation.equals("bottom"))
		{
			setTabPlacement(JTabbedPane.BOTTOM);
		}
		else if(orientation!=null && orientation.equals("right"))
		{
			setTabPlacement(JTabbedPane.RIGHT);
		}
		else
		{
			setTabPlacement(JTabbedPane.TOP);
		}
	}
	
	public void setLayout(String layout)
	{
		if(layout!=null)
		{
			try{
				Method method = getClass().getMethod("setTabLayoutPolicy",new Class[]{int.class});

				if(layout.equals("scroll"))
				{
					method.invoke( this,new Object[]{new Integer(getClass().getField("SCROLL_TAB_LAYOUT").getInt(this))} );
				}
				else
				{
					method.invoke( this,new Object[]{new Integer(getClass().getField("WRAP_TAB_LAYOUT").getInt(this))} );
				}

			}
			catch(Throwable e)
			{
				System.out.println("TabbedPane.setTabLayoutPolicy not available in JVM");
			}
		}
	}
	
	public void selectTab(int tabIndex)
	{
		setSelectedIndex( tabIndex );
	}
	
	public void removeTab( int tabIndex)
	{
		removeTabAt(tabIndex);
	}
	
	public XappTab getSelectedTab()
	{
		return getTab( getTabTitle(getSelectedIndex()) );
	}
	
	public String getTabTitle( int tabIndex )
	{
		return getTitleAt(tabIndex);
	}

	public void removeTab(XappTab tab) {
		removeTab( tab.getIndex() );
	}
}
