package org.one.stone.soup.xml.html;

import org.one.stone.soup.xml.*;
/*
 * Wet-Wired.com Xml Helpers Version Date 25-Aug-2004
 *
 * Copyright 2000-2001 by Wet-Wired.com Ltd.,
 * Portsmouth England
 * This software is OSI Certified Open Source Software
 * This software is covered by an OSI approved open source licence
 * which can be found at http://www.onestonesoup.org/OSSLicense.html
 */

/**
 * @author nikcross
 *
 */

// TODO
public class XmlToHtml {

	public static final String TAG = "#0000FF";
	public static final String NAME = "#A00000";
	public static final String ATTRIBUTE = "#00A000";
	public static final String DATA = "#000000";

	public static final String TAB = "<IMG SRC='images/clear-dot.gif' HEIGHT='1' WIDTH='30'>";
private XmlToHtml() {
	super();
}
public static String getTab( int level )
{
	StringBuffer buffer = new StringBuffer();
	for(int loop=0;loop<level;loop++)
	{
		buffer.append(TAB);
	}
	return buffer.toString();
}
public static void main(String[] args)
{
	XmlElement element = org.one.stone.soup.xml.stream.XmlLoader.load(args[0]);

	System.out.print( xmlToHtml(element) );
}
public static void xmlToHtml(StringBuffer buffer ,XmlElement element) {

	String tabbing = getTab( element.getLevel() );

	buffer.append( tabbing+"<FONT COLOR="+TAG+">&lt;</FONT>" );
	buffer.append( "<FONT COLOR="+NAME+">"+element.getName()+"</FONT>" );

	for(int loop=0;loop<element.getAttributeCount();loop++)
	{
		String attribName = element.getAttributeNameByIndex(loop);
		String attribValue = element.getAttributeValueByIndex(loop);

		buffer.append( " <FONT COLOR="+ATTRIBUTE+">"+attribName+"=\"</FONT><FONT COLOR="+DATA+">"+attribValue+"</FONT><FONT COLOR="+ATTRIBUTE+">\"</FONT>" );
	}

	if(element.getElementCount()>0)
	{
		buffer.append( "<FONT COLOR="+TAG+">&gt;</FONT><BR>\n" );

		String tabbing2 = getTab( element.getLevel()+1 );

		for(int loop=0;loop<element.getElementCount();loop++)
		{
			Object data = element.getData(loop);
			if(data instanceof String)
			{
				buffer.append(tabbing2+"<FONT COLOR="+DATA+">"+data.toString()+"</FONT><BR>\n");
			}
			else if(data instanceof XmlElement)
			{
				xmlToHtml(buffer,(XmlElement)data);
			}
		}

		buffer.append( tabbing+"<FONT COLOR="+TAG+">&lt;/</FONT>" );
		buffer.append( "<FONT COLOR="+NAME+">"+element.getName()+"</FONT>" );
		buffer.append( "<FONT COLOR="+TAG+">&gt;</FONT><BR>\n" );
	}
	else
	{
		buffer.append( "<FONT COLOR="+TAG+">/&gt;</FONT><BR>\n" );
	}
}
public static String xmlToHtml(XmlElement element) {

	StringBuffer buffer = new StringBuffer();
	xmlToHtml( buffer,element );

	return buffer.toString();
}
}
